/* $Id: progress.c 383 2009-08-16 09:21:26Z romain $ */

#include <stdio.h>

#include "progress.h"

#define PROGRESS_FD stdout

char steps[] = { '-', '\\', '|', '/' };
//char steps[] = { '.', 'o', 'O', 'o' };

void
progress_step(char status)
{
    static int s = -1;
    static unsigned char n = 0;

    if ((!status) && (n++ != 0))
	    return;

    if (s != -1) {
	fprintf(PROGRESS_FD, "\x8");
    }
    if (status)
	fprintf(PROGRESS_FD, "%c", status);

    s= ( s+ 1) % sizeof(steps);
    fprintf(PROGRESS_FD, "%c", steps[s]);
    fflush(PROGRESS_FD);
}

void
progress_end(void)
{
    fprintf(PROGRESS_FD, "\x8\n");
    fflush(PROGRESS_FD);
}
